Subject: bug#18413: Inline part displayed in the middle of its button

From: Stefan Monnier <[email-masked]>
Date: Fri, 05 Sep 2014 14:09:16 -0400

Package: emacs,gnus
Version: 24.4.50

Here's what I do:
- start Gnus
- visit a message with an Elisp attachment (in my case I tested with
  a message from Tom <[email-masked]> on emacs-devel with subject
  "Re: History for query replace pairs" and with an attachment of type
  "application/emacs-lisp").
- place cursor in the middle of the attachment's button (using keyboard
commands).
- press E

Result: the attachment is shown inline, but right in the middle of the
button.  IOW I get "[4. applicati" (from the button's text before
point), followed by the attachment's content, followed by
"on/emacs-lisp; hist.el]".  The whole is in bold for me, because the
button is an overlay with `bold' face, so the face ends up covering the
inline attachment as well.

It seems to be the result of the hunk below.

        Stefan

revno: 117041
committer: Katsumi Yamaoka <[email-masked]>
branch nick: trunk
timestamp: Fri 2014-05-02 09:44:34 +0000
message:
  Gnus: Make gnus-mime-inline-part and gnus-mime-inline-part work similarly
  
  * gnus-art.el (gnus-mime-inline-part): Redisplay a button so as to show
  the displaying state of a part.
  (gnus-mime-inline-part): Don't insert a newline in the beginning of
  a part like gnus-mime-inline-part doesn't; work for XEmacs.
  
  * mm-decode.el (mm-display-part): Don't insert a newline in the top.
  (mm-shr): Make undisplayer unbreakable.
  
  * mm-view.el (mm-inline-image-emacs, mm-inline-image-xemacs): Don't
  insert excessive newline.
  (mm-inline-text-html-render-with-w3m, mm-inline-text)
  (mm-insert-inline): Make undisplayer unbreakable.

--- lisp/gnus/mm-decode.el	2014-03-23 23:13:36 +0000
+++ lisp/gnus/mm-decode.el	2014-05-02 09:44:34 +0000
@@ -821,7 +821,6 @@
 	  'inline)
 	 ((and (mm-inlinable-p ehandle)
 	       (mm-inlined-p ehandle))
-	  (forward-line 1)
 	  (mm-display-inline handle)
 	  'inline)
 	 ((or method